diff --git a/drivers/hid/hid-logitech-dj.c b/drivers/hid/hid-logitech-dj.c
index 80b8788..386040b 100644
--- a/drivers/hid/hid-logitech-dj.c
+++ b/drivers/hid/hid-logitech-dj.c
@@ -459,6 +459,10 @@ static void delayedwork_callback(struct work_struct *work)
 						CONNECTION_STATUS_PARAM_STATUS];
 			connected = param_status != STATUS_LINKLOSS;
 			djrcv_dev->connected[dj_report.device_index] = connected;
+		} else {
+			/* Device paired notification, sent when asking for an
+			 * enumeration or after completing pairing */
+			connected = djrcv_dev->connected[dj_report.device_index];
 		}
 		djdev = djrcv_dev->paired_dj_devices[dj_report.device_index];
 		dbg_hid("%s: got REPORT_TYPE_NOTIF_CONNECTION_STATUS %d %d\n", __func__, djdev ? djdev->hid_device_started : -1, connected);
@@ -490,8 +494,9 @@ static void delayedwork_callback(struct work_struct *work)
 	 * hid-core discards all packets coming from a device while probe() is
 	 * executing. */
 	if (!djrcv_dev->paired_dj_devices[dj_report.device_index]) {
-		/* ok, we don't know the device, just re-ask the
-		 * receiver for the list of connected devices. */
+		/* ok, we don't know the device that just got conntected, just
+		 * re-ask the receiver for the list of connected devices. */
+		djrcv_dev->connected[dj_report.device_index] = true;
 		retval = logi_dj_recv_query_paired_devices(djrcv_dev);
 		if (!retval) {
 			/* everything went fine, so just leave */
